#pragma once

#include <vector>

class CSqlite3DB;
struct sqlite3_stmt;
struct sqlite3;


//handle a query 
class CSqlite3Statement
{
	friend class CSqlite3DB;
public:
	CSqlite3Statement(void);
	~CSqlite3Statement(void);

private:
	int Create(sqlite3 *pSQLite,const char *szSQL);	//create statement according to sql
	int GetFieldIndex(CString fieldName);	//get the index of field according to field name
	int GetFieldIndex(const char *szFieldName);	//get the index of field according to field name

public:
	int Execute();	//execute sql,not implement

	int BindInt(const char* szFieldName,int val);	//bind integer value to field
	int BindInt(CString fieldName,int val);	//bind integer value to field	

	int BindInt64(CString fieldName,__int64 val);	//bind integer(64bit) value to field	
	int BindInt64(const char* szFieldName,__int64 val);	//bind integer(64bit) value to field	

	int BindText(const char* szFieldName,const CString& val);
	int BindText(const char* szFieldName,const char* val);	//bind string value to field

	int BindBlob(const char* szFieldName,const unsigned char* val,int len);	// bind binary data to field
	int BindTime(const char* szFieldName,CTime &tm);	//bind time to field

	int GetIntValue(CString fieldName);	//get field value,then convert it to integer
	int GetIntValue(const char *szFieldName);	//get field value,then convert it to integer

	int GetBlobLength(CString fieldName);	//get length of binary value from sqlite
	unsigned char* GetBlobValue(CString fieldName);	//get binary value from sqlite
	unsigned char* GetBlobValue(const char * szFieldName);	//get binary value from sqlite

	CString GetTextValue(const char *szFieldName);	//get text value from sqlite
	CTime GetTime(const char *szFieldName);

	

	int Close();	//close statement
	int Next(); //fetch next row.


private:
	sqlite3			*m_pSQLite;	//sqlite db pointer.
	sqlite3_stmt	*m_pstmt;	//sqlite statement
	std::vector<char*>	m_vecValue;
};
